#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "address_type4xi.py">
#<abstract4xi abstract = "provides the function address_type4xi" />
#<refer4xi reference = "connection.py" />
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
#<note4xi note = "no changes in [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'address_type4xi' ]
#"
#/>

# --------------------------------------- ----------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass    
try:                 # most-common ones
    import errno
    import time
    import tempfile
    import itertools         
except:
    pass
try:                 # rare ones
    import socket          
except:
    pass 
         
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
#"
#/>
 
# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from constant_family4xi import get_af_inet4xi
from constant_family4xi import get_af_unix4xi
from constant_family4xi import get_af_pipe4xi
from constant_family4xi import get_default_family4xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>




# -------------------------------------------------------------------------------------------------
#<function4xi function = "address_type4xi" usage = "
#   socketclient4xi.py
#        SocketClient4Xi
#             family2xi = address_type4xi(address)
#">
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/> 
# -------------------------------------------------------------------------------------------------
def address_type4xi(address):
    '''
    returns the types of the address which can be 'AF_INET', 'AF_UNIX', or 'AF_PIPE'
    '''
                
    # ---------------------------------------------------------------------------------------------    
    # (Step 1/6)
    # ---------------------------------------------------------------------------------------------        
  
    class2print = 'address_type4xi'
    method2print = 'address_type4xi'
    
    message2print = "{(Step 1/6a) started" + "; address-type4xi-started: " + str(address_type4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    
    message2print = "{(Step 1/6b) passed" + "; address-passed-to-address-type4xi: " + str(address) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   

    ack2type = False #dragonized
    
    if type(address) == tuple:
                
        # -----------------------------------------------------------------------------------------    
        # (Step 2/6)
        # -----------------------------------------------------------------------------------------        
 
        type2xi = get_af_inet4xi()

        message2print = "{(Step 2/6) set" + "; type2xi-set-by-address-type4xi to: " + str(type2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                        
        ack2type = True
        
    if ((type(address) == tuple) and (ack2type is False)):
             
        # -----------------------------------------------------------------------------------------    
        # (Step 3/6)
        # -----------------------------------------------------------------------------------------        

        type2xi = get_af_pipe4xi()

        message2print = "{(Step 3/6) set" + "; type2xi-set-by-address-type4xi to: " + str(type2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                        
        ack2type = True
                
        
    if ((type(address) is str) and ((ack2type is False))):
                
        # -----------------------------------------------------------------------------------------    
        # (Step 4/6)
        # -----------------------------------------------------------------------------------------        

        type2xi = get_af_unix4xi()

        message2print = "{(Step 4/6) set" + "; type2xi-set-by-address-type4xi to: " + str(type2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                        
        ack2type = True
                 
    if ack2type is False:
                
        # -----------------------------------------------------------------------------------------    
        # (Step 5/6) - dragonized by returning default family
        # -----------------------------------------------------------------------------------------        
        type2xi = get_default_family4xi() 

        message2print = "{(Step 5/6a) set" + "; type2xi-set-by-address-type4xi to: " + str(type2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  

        message2print = "{(Step 5/6b) yielded" + "; type2xi-yielded-by-address-type4xi: " + str(type2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        
                                
        ack2type = True
                         
                
    # ---------------------------------------------------------------------------------------------    
    # (Step 6/6)
    # ---------------------------------------------------------------------------------------------        
    message2print = "{(Step 6/6) returning" + "; type2xi-returning-by-address-type4xi: " + str(type2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
            
    return type2xi        
    
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of address_type4xi.py                            
# ------------------------------------------------------------------------------------------------- 
#"
#/>

